#!/usr/bin/perl

#Not required if you install the perl modules as root. Change accordingly if you didnt.
use lib '/home/bio/.irssi/scripts/libdata/perl5';
use lib '/home/bio/.irssi/scripts/libdata/perl5/site_perl';
use lib '/home/bio/.irssi/scripts/libdata/perl5/i386-openbsd/5.10.0';
use lib '/home/bio/.irssi/scripts/libdata/perl5/site_perl/i386-openbsd';
use strict;
use warnings;
use LWP::Simple;
use JSON;
use Time::Local;
use Irssi;
use utf8;

use vars qw($VERSION %IRSSI);

$VERSION = '1.2';
%IRSSI = (
    authors	=> 'Bi()ha2arD',
    contact	=> '#ut3gonebad @ QuakeNet',
    name	=> 'bc2bot',
    description => 'gets stats and shit for bc2',
    license	=> 'Public Domain',
);


#COLOURS
Irssi::settings_add_int('bc2bot','C_BRACKETS','14');
Irssi::settings_add_int('bc2bot','C_TEXT','10');
Irssi::settings_add_int('bc2bot','C_VALUES','11');

our $BR="" . Irssi::settings_get_int('C_BRACKETS'); #[
our $TE="" . Irssi::settings_get_int('C_TEXT'); #normal text
our $VA="" . Irssi::settings_get_int('C_VALUES'); #values
our $RED="05"; #deaths
our $LASTFILE=Irssi::get_irssi_dir() . "/lastonline";
our $NAMEFILE=Irssi::get_irssi_dir() . "/bc2names";
our $PUGFILE=Irssi::get_irssi_dir() . "/pugfile";
our $TIMEOUT;

sub UPDATECOLS
{
$BR="" . Irssi::settings_get_int('C_BRACKETS'); #[
$TE="" . Irssi::settings_get_int('C_TEXT'); #normal text
$VA="" . Irssi::settings_get_int('C_VALUES'); #values
print "Colours updated!";
}


our $cache;

sub READCACHE
{
    open(my $in, "<", $LASTFILE ) or print "ERROR! Couldn't open cachefile: $!";
    my $line = <$in>;
    close($in);
    chomp($line);
    $cache=decode_json($line);
}

our $ignames;

sub READNAMES
{
    open(my $in, "<", $NAMEFILE ) or print "ERROR! Couldn't open namefile: $!";
    my $line = <$in>;
    close($in);
    chomp($line);
    $ignames=decode_json($line);
}

our $pug;

sub READPUGS
{
    open(my $in, "<", $PUGFILE ) or print "ERROR! Couldn't open pugfile: $!";
    my $line = <$in>;
    close($in);
    chomp($line);
    $pug=decode_json($line);
}



#GRAB STATS
sub GETDATA
{
    my $server = $_[2];
    my $target = $_[3];
    my $silent = $_[4];
    my $URL = "http://api.bfbcs.com/api/pc?players=$_[0]&fields=$_[1]";
#    print $URL;
    my $RAWDATA;
    unless (defined ($RAWDATA = get($URL))) { unless ($silent) {$server->command("MSG $target ${RED}Error getting stats");} return ; };
#    print $RAWDATA;
    unless ( $RAWDATA =~ /^\{\"/ ) { if ($silent) {print "Stats site did not return a JSON object!";} else { $server->command("MSG $target ${RED}Error: Server did not return a JSON string!");} return; }
    my $DATA = decode_json $RAWDATA;
        if ($DATA->{ 'found' } != $DATA->{ 'requested' }) { unless ($silent) {$server->command("MSG $target ${VA}$_[0] ${TE}not found.");} return; }
    return $DATA;
}

#my $FOO = &GETDATA("dmnc","general,progress,online");

#if ($FOO->{ 'found' } == 0)
#{
#    print "Player not found \n";
#}

#print $FOO->{ 'players' }[0]->{ 'name' };  //returns Bi()ha2arD
#			player
#{players <- players (array), requested, found BIG HASH
#	[ <- array of players
#	    { HASH OF STUFF (name, platform, rank,
#		    "general":{ "stuff" <- HASH INSIDE THE ARRAY INSIDE THE HASH
#			    .
#			    .
#			    .
#				}
#	    }
#	{hash for next player}
#	]
#}
#
#print $FOO->{ 'players' }[0]->{ 'general' }->{ 'accuracy' };

#incoming time format is something like 2010-12-30T21:48:29+00:00
#in other words:			YYYY-MM-DDtHH:MM:SS

#CHECK IF ONLINE, used by other functions
sub ONLINE
{
    my $TIME=$_[1];
    if (defined $_[0])
    {
	my $LASTOL = $_[0];
	$LASTOL =~ s/[T]|[:]|[\+]/\-/g;
        my @LAST = split('-',$LASTOL);
	my $LASTSECONDS = timegm($LAST[5],$LAST[4],$LAST[3],$LAST[2],$LAST[1]-1,$LAST[0]);
	my $NOWSECONDS = timelocal(localtime);
#	print $LASTSECONDS . "\n";
#	print $NOWSECONDS ."\n";
	if ( $NOWSECONDS-$LASTSECONDS > $TIME)
	{
	    return 0;
	}
	    else
	    { return 1 }
    } else { return 0 }
}


#CHECK THE LIST FOR ONLINE PLAYERS
sub OLCHECK
{
    my ($server,$target)=@_;
    $server->command("MSG $target ${TE}Checking online status...");
    my $LIST=Irssi::settings_get_str('onlinelist');
    my $STATS=&GETDATA("$LIST","online",$server,$target,undef);
    if (defined $STATS) {my @ONLINE = ();
    for (my $n = 0; $n < $STATS->{ 'found' }; $n++)
    {
	if (&ONLINE($STATS->{ 'players' }[$n]->{ 'lastonline' },300)){
	push(@ONLINE, $STATS->{ 'players' }[$n]->{ 'name' });
	}
    }
    if (@ONLINE == 0)
    { $server->command("MSG $target ${TE}Nobody is online!"); }
    else
    { my $TEXT = "${TE}Currently online: ${VA}" . "@ONLINE"; $server->command("MSG $target $TEXT"); }
    }
}


#NOT USED ANYMORE, CACHED
#sub ACTIVE {
#    my ($server,$target)=@_;
#    my $LIST = Irssi::settings_get_str('onlinelist');
#    my $STATS=&GETDATA("$LIST","online",$server,$target,undef);
#    if (defined $STATS) {my @ACTIVE = ();
#    for (my $n = 0; $n < $STATS->{ 'found' }; $n++)
#    {
#	if (&ONLINE($STATS->{ 'players' }[$n]->{ 'lastonline' },2592000))
#	{
#	    push(@ACTIVE, $STATS->{ 'players' }[$n]->{ 'name' });
#	}
#    }
#    if (@ACTIVE == 0)
#    { $server->command("MSG $target ${TE}Nobody is active!"); }
#    else
#    { my $TEXT="${TE}Active players: ${VA}" . "@ACTIVE"; $server->command("MSG $target $TEXT"); }
#    }
#}


#SEARCH PLAYER AND RETURN LINK TO GAMETRACKER
sub FIND
{
    my $server=$_[1];
    my $target=$_[2];
    my $STATS=&GETDATA("$_[0]","online",$server,$target,undef);
    if (defined $STATS){
    if (&ONLINE($STATS->{ 'players' }[0]->{ 'lastonline' },300))
    {
	$server->command("MSG $target ${VA}$STATS->{ 'players' }[0]->{ 'name' } ${TE}is playing on ${VA}http://www.gametracker.com/server_info/$STATS->{ 'players' }[0]->{ 'server' }->{ 'addr' }");
    }
    else { $server->command("MSG $target ${VA}$STATS->{ 'players' }[0]->{ 'name' } ${TE}is offline."); }
    }
}


#THE STATS OUTPUT
sub STATISTICS
{
    my $server=$_[1];
    my $target=$_[2];
    my $STATS=&GETDATA("$_[0]","general,progress,online",$server,$target,undef);
    if (defined $STATS) {
    my $TOGOSTRING="";
    unless ($STATS->{ 'players' }[0]->{ 'progress' }->{ 'score' } eq "false")
    {
	my $TOGO = $STATS->{ 'players' }[0]->{ 'progress' }->{ 'score' }->{ 'next' } - $STATS->{ 'players' }[0]->{ 'progress' }->{ 'score' }->{ 'curr' };
	$TOGOSTRING="${TE}, ${VA}$TOGO ${TE}to go for Promotion";
    }
    my $KDR;
    if ($STATS->{ 'players' }[0]->{ 'deaths' } == 0 ){
	$KDR="$STATS->{ 'players' }[0]->{ 'kills' }";
    } else {
	$KDR=sprintf  '%.2f', ($STATS->{ 'players' }[0]->{ 'kills' }/$STATS->{ 'players' }[0]->{ 'deaths' });
    }
    my $KDRCOL="16";
    if ($KDR <= .5){ $KDRCOL="14"; } elsif ($KDR <= 1.5){ $KDRCOL="15"; }
    my $TEXT = "${BR}[ ${TE}Name: ${VA}$STATS->{ 'players' }[0]->{ 'clantag' } $STATS->{ 'players' }[0]->{ 'name' } ${BR}| ${TE}Rank: ${VA}$STATS->{ 'players' }[0]->{ 'rank' }${TE}, ${VA}$STATS->{ 'players' }[0]->{ 'rank_name' } ${BR}]\n${BR}[ ${TE}Playtime: ${VA}" . int($STATS->{ 'players' }[0]->{ 'time' }/3600) ." ${TE}h ${BR}| ${TE}Score: ${VA}$STATS->{ 'players' }[0]->{ 'score' }$TOGOSTRING ${BR}]\n${BR}[ ${TE}Kills: ${VA}$STATS->{ 'players' }[0]->{ 'kills' } ${BR}| ${TE}Deaths: ${RED}$STATS->{ 'players' }[0]->{ 'deaths' } ${BR}| ${TE}KDR: ${KDRCOL}$KDR ${BR}]";
#    my @LINES=split("\n",$TEXT);
#    foreach(@LINES) {$server->command("MSG $target $_");}
    if (&ONLINE($STATS->{ 'players' }[0]->{ 'lastonline' },300))
    {
#	$server->command("MSG $target ${BR}[ ${VA}$STATS->{ 'players' }[0]->{ 'clantag' } $STATS->{ 'players' }[0]->{ 'name' } ${TE}is online now! ${BR}]");
    $TEXT=$TEXT . "\n${BR}[ ${VA}$STATS->{ 'players' }[0]->{ 'clantag' } $STATS->{ 'players' }[0]->{ 'name' } ${TE}is online now! ${BR}]";
    } else {
    my $DATE=$STATS->{ 'players' }[0]->{ 'lastonline' };
    if (defined $DATE){
    $DATE=~ s/T|\+/-/g;
    my @DAT=split("-",$DATE);
    my $DATEFOO = "$DAT[2].$DAT[1].$DAT[0], $DAT[3]";
#    $server->command("MSG $target ${BR}[ ${TE}Last seen: ${VA}$DATEFOO GMT ${BR}]");
    $TEXT=$TEXT . "\n${BR}[ ${TE}Last seen: ${VA}$DATEFOO GMT ${BR}]";
    }
    }
    my @LINES=split("\n",$TEXT);
    foreach(@LINES) {$server->command("MSG $target $_");}
    }
}


sub STATUS
{
    my $server=$_[1];
    my $target=$_[2];
    my $STATS=&GETDATA("$_[0]","basic",$server,$target,undef);
    if (defined $STATS) {
        my ($LASTUPDATE,$LASTCHECK,$QUEUE);
	my $DATE=$STATS->{ 'players' }[0]->{ 'date_lastupdate' };
	if (defined $DATE){
	    $DATE=~ s/T|\+/-/g;
	    my @DAT=split("-",$DATE);
	    $LASTUPDATE = "$DAT[2].$DAT[1].$DAT[0], $DAT[3]";
	}
	$DATE=$STATS->{ 'players' }[0]->{ 'date_lastcheck' };
	if (defined $DATE){
	    $DATE=~ s/T|\+/-/g;
	    my @DAT=split("-",$DATE);
	    $LASTCHECK = "$DAT[2].$DAT[1].$DAT[0], $DAT[3]";
	}
	if ($STATS->{ 'players' }[0]->{ 'queue' } ) {
	    $QUEUE="\n${TE}Queue position: ${VA}$STATS->{ 'players' }[0]->{ 'queue' }";
	} else { $QUEUE=""; }
    my $TEXT= "${BR}--[ $STATS->{ 'players' }[0]->{ 'name' } ${BR}]--\n${TE}Stats last updated: ${VA}$LASTUPDATE GMT ${BR}| ${TE}Last checked: ${VA}${LASTCHECK}${QUEUE}";
    my @LINES=split("\n",$TEXT);
    foreach(@LINES) {$server->command("MSG $target $_");}



}
}


sub WEAPONS
{
    my $server=$_[1];
    my $chan=$_[2];
    my $nick=$_[3];
    my $all=$_[4];
    my $STATS=&GETDATA("$_[0]","weapons,gadgets,vehicles",$server,$chan,undef);
    if (defined $STATS) {
    my %temp;
    my @top;
   # my %weapons=%{$STATS->{ 'players' }[0]->{ 'weapons' }};
   # print %weapons;
    for my $gun ( keys %{$STATS->{ 'players' }[0]->{ 'weapons' }} ) {
	$temp{ $gun }=$STATS->{ 'players' }[0]->{ 'weapons' }->{ $gun }->{ 'kills' };
    }
    foreach my $key (sort {$temp{$b} <=> $temp{$a} } keys %temp) {
	push(@top,{ 'name' => "$STATS->{ 'players' }[0]->{ 'weapons' }->{ $key }->{ 'name' }", 'kills' => "$STATS->{ 'players' }[0]->{ 'weapons' }->{ $key }->{ 'kills' }", 'hs' => "$STATS->{ 'players' }[0]->{ 'weapons' }->{ $key }->{ 'headshots' }" });
    }
#    my $TEXT= "${BR}[ ${VA}$STATS->{ 'players' }[0]->{ 'name' }\'s favourite guns: ${BR}]";
#    for (my $n=0; $n <= 4; $n++)
#    { $TEXT="$TEXT" . "\n${VA}$top[$n]->{ 'name' }${TE}, Kills: ${VA}$top[$n]->{ 'kills' }${TE}, Headshots: ${VA}$top[$n]->{ 'hs' }"; }

    #GADGETS
    my %gadgets;
    my @tools;
    for my $gadget ( keys %{$STATS->{ 'players' }[0]->{ 'gadgets' }} ) {
	$gadgets{ $gadget }=$STATS->{ 'players' }[0]->{ 'gadgets' }->{ $gadget }->{ 'kills' } if defined $STATS->{ 'players' }[0]->{ 'gadgets' }->{ $gadget }->{ 'kills' };
    }
    foreach my $key (sort {$gadgets{$b} <=> $gadgets{$a} } keys %gadgets) {
	push(@tools,{ 'name' => "$STATS->{ 'players' }[0]->{ 'gadgets' }->{ $key }->{ 'name' }", 'kills' => "$STATS->{ 'players' }[0]->{ 'gadgets' }->{ $key }->{ 'kills' }"});
    }
#    $TEXT="$TEXT" . "\n${TE}Top Gadget: ${VA}$tools[0]->{ 'name' }${TE}, Kills: ${VA}$tools[0]->{ 'kills' }";
#    for (my $n=0; $n <= 4; $n++)
#    { $TEXT="$TEXT" . "\n${VA}$top[$n]->{ 'name' } ${BR}-- ${TE}Kills: ${VA}$top[$n]->{ 'kills' } ${BR}-- ${TE}Headshots: ${VA}$top[$n]->{ 'hs' }"; }

    #VEHICLES
    my %veh;
    my @cars;
    for my $car ( keys %{$STATS->{ 'players' }[0]->{ 'vehicles' }} ) {
	$veh{ $car }=$STATS->{ 'players' }[0]->{ 'vehicles' }->{ $car }->{ 'kills' } if defined $STATS->{ 'players' }[0]->{ 'vehicles' }->{ $car }->{ 'kills' };
    }
    foreach my $key (sort {$veh{$b} <=> $veh{$a} } keys %veh) {
	push(@cars,{ 'name' => "$STATS->{ 'players' }[0]->{ 'vehicles' }->{ $key }->{ 'name' }", 'kills' => "$STATS->{ 'players' }[0]->{ 'vehicles' }->{ $key }->{ 'kills' }"});#, 'rk' => "$STATS->{ 'players' }[0]->{ 'vehicles' }->{ $key }->{ 'roadkills' }"}); roadkills not set for all, ugly.
    }
#    $TEXT="$TEXT" . "\n${TE}Top Vehicle: ${VA}$cars[0]->{ 'name' }${TE}, Kills: ${VA}$cars[0]->{ 'kills' }${TE}, Roadkills: ${VA}$cars[0]->{ 'rk' }";


    #OUTPUT

    if ($all) {
    my $TEXT= "${BR}[ ${VA}$STATS->{ 'players' }[0]->{ 'name' }\'s - Guns ${BR}] - ";
    for (my $n=0; $n < scalar(@top); $n++)
    {
    my $div=" ${BR}| ";
    if ( (($n+1)%8==0 ) && (($n+1)< scalar(@top) )){ $div="\n"; }
    $TEXT="$TEXT" . "${VA}$top[$n]->{ 'name' }${TE}, K: ${VA}$top[$n]->{ 'kills' }${TE}, HS: ${VA}$top[$n]->{ 'hs' }$div"; }
    $TEXT="$TEXT"."\n${BR}[ ${VA}Gadgets ${BR}] - ";
    for (my $n=0; $n < scalar(@tools); $n++)
    {
    my $div=" ${BR}| ";
    if ( (($n+1)%9==0 ) && (($n+1)< scalar(@tools) )){ $div="\n"; }
    $TEXT="$TEXT" . "${VA}$tools[$n]->{ 'name' }${TE}, K: ${VA}$tools[$n]->{ 'kills' }$div"; }
    $TEXT="$TEXT"."\n${BR}[ ${VA}Vehicles ${BR}] - ";
    for (my $n=0; $n < scalar(@cars); $n++)
    {
    my $div=" ${BR}| ";
    if ( (($n+1)%9==0 ) && (($n+1)< scalar(@cars) )){ $div="\n"; }
    $TEXT="$TEXT" . "${VA}$cars[$n]->{ 'name' }${TE}, K: ${VA}$cars[$n]->{ 'kills' }${TE}$div";}#, Roadkills: ${VA}$cars[$n]->{ 'rk' }"; }
    my @LINES=split("\n",$TEXT);
    foreach(@LINES) {$server->command("MSG $nick $_");}

    }
    else {

    my $TEXT= "${BR}[ ${VA}$STATS->{ 'players' }[0]->{ 'name' }\'s favourite guns: ${BR}]";
    for (my $n=0; $n <= 4; $n++)
    { $TEXT="$TEXT" . "\n${VA}$top[$n]->{ 'name' }${TE}, Kills: ${VA}$top[$n]->{ 'kills' }${TE}, Headshots: ${VA}$top[$n]->{ 'hs' }"; }
    $TEXT="$TEXT" . "\n${TE}Top Gadget: ${VA}$tools[0]->{ 'name' }${TE}, Kills: ${VA}$tools[0]->{ 'kills' }";
    $TEXT="$TEXT" . "\n${TE}Top Vehicle: ${VA}$cars[0]->{ 'name' }${TE}, Kills: ${VA}$cars[0]->{ 'kills' }${TE}";#, Roadkills: ${VA}$cars[0]->{ 'rk' }";

    my @LINES=split("\n",$TEXT);
    foreach(@LINES) {$server->command("MSG $chan $_");}
    }

}}



sub TOPTEN
{
    my ($STATS,$what)=@_;
    my %SCORES=();
    for (my $n = 0; $n < $STATS->{ 'found' }; $n++)
    {
	my $statistic = 'score';
	if ($what != 0 ) { $statistic = 'time'; }
	$SCORES{ "$STATS->{ 'players' }[$n]->{ $statistic }" } = "$STATS->{ 'players' }[$n]->{ 'name' }";
    }
    my @SORTEDPLAYERS;
    foreach my $key(sort {$a <=> $b} keys %SCORES){
	my $keystring = $key;
	if ($what != 0 ) { $keystring = int( $key / 3600 ) . " h"; }
	unshift(@SORTEDPLAYERS,"${VA}$SCORES{$key} ${BR}\(${TE}$keystring${BR}\)");
    }
    my $max = 9;
    if ($STATS->{ 'found' } < 10) { $max = $STATS->{ 'found' } - 1; }
    my @TEN = @SORTEDPLAYERS[0..$max];
    for (my $n = 0; $n <= $max; $n++ ){
	my $num = $n + 1;
	$TEN[$n] = "${VA}$num${BR}. $TEN[$n]";
    }
    my $TEXT="${BR}Top 10: " . "@TEN";
    return $TEXT;
}


sub GETTITLE
{
#done in call    unless ( Irssi::settings_get_bool('urltitle') ) { return; }
    my ($server,$target,$url)=@_;
    unless ( $url =~ /(\.(jpe?g|a?png|gif|rar|zip|7z|gz|bin))$/i ) {
	$url =~ s/(\(|\))/\\$1/g;
	my $RAWDATA;
	$RAWDATA=qx(curl -L -s --globoff --max-filesize 1048576 -m 8 $url);
	unless (defined $RAWDATA ) { return; }
	#unless ( $? == 0 ) { return; }
	if ( $RAWDATA eq "" ) { print "$url unreachable"; return; }
	my $failsafe = $RAWDATA=~ m{<TITLE>(.*?)</TITLE>}is;
	$RAWDATA=$1;
	if ($failsafe) {
	    my $title=html_dec($RAWDATA);
	    #if ( $RAWDATA  eq $url ) { return; }
	    #$RAWDATA=~ s/^\s+//;
	    #$RAWDATA=~ s/\s+$//;
	    #$RAWDATA=~ s/\s+/ /g;
	    $server->command("MSG $target ${BR}Title: $title");
	}
	return;
    }
    return;
}


sub html_dec {
    my $text = $_[0];
    #return $text;
    if (not defined $text) { return $text; }
    my %re=(
	amp	=> '&',
	auml	=> 'ä',
	Auml	=> 'Ä',
	aelig	=> 'æ',
	Aelig	=> 'Æ',
	agrave	=> 'à'.
	Agrave	=> 'À',
	bdquo	=> '"',	#todo
	bull	=> '•',
	circ	=> '^',
	deg	=> '°',
	emsp	=> ' ',
	ensp	=> ' ',
	euro	=> '€',
	frasl	=> '/',
	gt	=> '>'.
	laquo	=> '«',
	ldquo	=> '"',	#todo
	lt	=> '<',
	lsquo	=> '`',
	mdash	=> '-',
	minus	=> '-',
	nbsp	=> ' ',
	ndash	=> '-',
	ouml	=> 'ö',
	Ouml	=> 'Ö',
	Prime	=> '"',
	prime	=> '\'',
	pound	=> '£',
	quot	=> '"',
	raquo	=> '»',
	rdquo	=> '"',
	rsaquo	=> '>',
	lsaquo	=> '<',
	rsquo	=> '´',
	sect	=> '§',
	szlig	=> 'ß',
	thinsp	=> ' ',
	tilde	=> '~',
	Uuml	=> 'Ü',
	uuml	=> 'ü',
#	'#039'	=> '\'',
	trade	=> '™'
	);
    my %renum=(
	39  => '\'',
	38  => '&',
	62  => '>',
	60  => '<',
	34  => '"'
	);

    $text=~ s/^\s+//;
    $text=~ s/\s+$//;
    $text=~ s/\s+/ /g;

    for my $ent (keys %re) {
        $text =~ s/\&$ent\;/$re{$ent}/g;
    }
    for my $nument (keys %renum) {
	$text =~ s/\&#(0+)?$nument\;/$renum{$nument}/g;
    }
    return $text;
}




sub LAST
{
#print "Checking LAST";
    my ($server,$target) = @_;
    my $list=Irssi::settings_get_str('onlinelist');
    my $STATS=&GETDATA($list,'online',$server,$target,'1');
    if (defined $STATS) {


#CACHE TOP10 ADDICTED ACTIVE
    #active
    my @ACTIVE = ();
    for (my $n = 0; $n < $STATS->{ 'found' }; $n++)
    {
	if (&ONLINE($STATS->{ 'players' }[$n]->{ 'lastonline' },2592000))
	{
	    push(@ACTIVE, $STATS->{ 'players' }[$n]->{ 'name' });
	}
    }
    if (@ACTIVE == 0)
    { $cache->{ 'active' } = "${TE}Nobody is active!"; }
    else
    { $cache->{ 'active' }="${TE}Active players: ${VA}" . "@ACTIVE"; }

    #TOP10 & Addicted
    $cache->{ 'top10' }=&TOPTEN($STATS,0);
    $cache->{ 'addicted' }=&TOPTEN($STATS,1);



#DO YER THANG for LAST
    my $LASTOL={};
    my ($SRV,$TIME);
    $SRV="just testing";
    my @PLAYERS=();
    my @LOL=();
    #FILTER PLAYERS WHO NEVER PLAYED AND CONVERT LAST PLAYED TO SECS
#    if (not defined($STATS)) {print "Error getting Stats"; return; }
    for (my $n=0; $n < $STATS->{ 'found' }; $n++){
	if (defined( $STATS->{ 'players' }[$n]->{ 'lastonline' } )){
	    my $LASTONLINE = $STATS->{ 'players' }[$n]->{ 'lastonline' };
	    $LASTONLINE =~ s/[T]|[:]|[\+]/\-/g;
	    my @LAST = split('-',$LASTONLINE);
	    my $LASTSECONDS = timegm($LAST[5],$LAST[4],$LAST[3],$LAST[2],$LAST[1]-1,$LAST[0]);
	    $LASTOL->{ $n } = $LASTSECONDS;
	    $STATS->{ 'players' }[$n]->{ 'lastonline' } = $LASTSECONDS;
#	    print "$LASTOL->{ $n }, $n, $LASTSECONDS, $STATS->{ 'players' }[ $n ]->{ 'name' }";
	    }
    }
#print %LASTOL;
    #BUILD ARRAY SORTED BY TIME
    foreach my $n( sort {$LASTOL->{$b} <=> $LASTOL->{$a}} (keys(%$LASTOL))){
#	if ( $loopcount == 0 ){
#	    $SRV = $STATS->{ 'players' }[$LASTOL{ $n }]->{ 'server' }->{ 'name' };
#	    $TIME = $STATS->{ 'players' }[$LASTOL{ $n }]->{ 'lastonline' };
#	    }
#	$loopcount++;
#	print "key $n, Value: $LASTOL->{ $n }";
	push @LOL, {
			player => $STATS->{ 'players' }[$n]->{ 'name' },
			lastonline => $STATS->{ 'players' }[$n]->{ 'lastonline' },
			server => $STATS->{ 'players' }[$n]->{ 'server' }->{ 'name' },
			ip => $STATS->{ 'players' }[$n]->{ 'server' }->{ 'addr' }
		    };
    }

#debug
#   print "ARRAY:";
#    for (my $d=0; $d < scalar(@LOL); $d++){print "$LOL[$d]->{ 'player' }, $LOL[$d]->{ 'lastonline' }, $LOL[$d]->{ 'ip' }";}


#print "@LOL";
#    my $m=0;
#    my $num = @LOL;
    my $loopcount = 0;
#KEEP LOOPING LOOPING LOOPING LOOPING
    for (my $n=0; $n < scalar(@LOL); $n++){
#    print "in the 1st loop";
	for (my $m=$n+1; $m < scalar(@LOL); $m++){
#	print "in the 2nd loop";
	    if ((($LOL[$n]->{ 'lastonline' } - $LOL[$m]->{ 'lastonline' }) < 3600) && ($LOL[$n]->{ 'ip' } eq $LOL[$m]->{ 'ip' })) {
#	    print "found a match!";
		if ( $loopcount == 0){
		    $SRV = $LOL[$n]->{ 'server' };
		    $TIME = $LOL[$m]->{ 'lastonline' };
		    $loopcount++ #This shouldn't be needed i think but w/e
		}
		#if (-r $LASTFILE) {
		#my @TEMP=();
		#my $numline=0;
		#open(my $in, "<", $LASTFILE ) or return;
		#while( my $line = <$in> ){
		#	chomp($line);
		#	$TEMP[$numline]=$line;
		#	$numline++
		#}
		if ( $TIME <= $cache->{ 'lasttime' }) {
		    my $outtext=encode_json($cache);
		    open( my $out, ">", $LASTFILE ) or print "Couldn't write cachefile!";
		    print $out "$outtext";
		    close($out);
		    return; } #people changed server so the condition doesnt match anymore, but it matches for an older game so it would overwrite our current game

		push(@PLAYERS,($LOL[$n]->{ 'player' },$LOL[$m]->{ 'player' }));
		for (my $x=$m+1; $x < scalar(@LOL); $x++){
		    if ((($LOL[$n]->{ 'lastonline' } - $LOL[$x]->{ 'lastonline' }) < 3600) && ($LOL[$n]->{ 'ip' } eq $LOL[$x]->{ 'ip' })) {
			push(@PLAYERS,$LOL[$x]->{ 'player' });
		    }
		}
	    last;
	    }
	}
	if ( scalar(@PLAYERS) != 0 ) {
	    last;
	}
    }



    if ( scalar(@PLAYERS) == 0 ) {
	my $outtext=encode_json($cache);
	open( my $out, ">", $LASTFILE ) or print "Couldn't write cachefile!";
	print $out "$outtext";
	close($out);
	return;
    } #NOBODY WAS ONLINE
    else {
    my $pls = "@PLAYERS";
#    $server->command("MSG $target ${TE}Last game was $timestr ${TE}ago on the server \"${VA}$SRV\"${TE}.");
#    $server->command("MSG $target ${TE}Playing were: ${VA}$pls");
#    open( my $out, ">", $LASTFILE ) or return;
#    print $out "$TIME" . "\n" . "@PLAYERS" . "\n" . "$SRV";
    $cache->{ 'lasttime' }=$TIME;
    $cache->{ 'lastplayers' }="@PLAYERS";
    $cache->{ 'lastsrv' }=$SRV;
    my $outtext=encode_json($cache);
    open( my $out, ">", $LASTFILE ) or print "Couldn't write cachefile!";
    print $out "$outtext";
    close($out);

    }
    }
}

sub LASTOUT
{
    my($server,$target)=@_;
    if (not defined $TIMEOUT) { $server->command("MSG $target ${RED}WARNING: Periodic updates are off!"); }
#    my @DATA=();
#    my $numline=0;
#    open(my $in, "<", $LASTFILE ) or return;
#    while( my $line = <$in> ){
#	chomp($line);
#	$DATA[$numline]=$line;
#	$numline++
#	}


    my $NOW = timelocal(localtime);
#print $NOW;
    my $LAOL = $NOW-$cache->{ 'lasttime' };
    my @parts=gmtime($LAOL);
#print "@parts";
    my $timestr;
    my ($days,$weeks,$hours);
    $weeks="";
    $days="";
    $hours="";
    if ($parts[7] >= 7){
	$weeks="${VA}"."int($parts[7] / 7)"." ${BR}weeks, ";
	$parts[7] = $parts[7] % 7;
#	$timestr = "${VA}$weeks ${BR}weeks, ${VA}$days ${BR}days, ${VA}$parts[2] ${BR}hours and ${VA}$parts[1] ${BR}minutes";
    }
    if ($parts[7] != 0) { $days="${VA}$parts[7] ${BR}days, "; }
    if ($parts[2] != 0) { $hours="${VA}$parts[2] ${BR}hours, "; }
    #    else{ $timestr = "${VA}$parts[7] ${BR}days, ${VA}$parts[2] ${BR}hours and ${VA}$parts[1] ${BR}minutes"; }
    $timestr="${weeks}${days}${hours}${VA}$parts[1] ${BR}minutes";
#    my $pls=$DATA[1];
    $server->command("MSG $target ${TE}Last game was $timestr ${TE}ago on the server \"${VA}$cache->{ 'lastsrv' }${TE}\".");
    $server->command("MSG $target ${TE}Playing were: ${VA}$cache->{ 'lastplayers' }");
}

sub HELLO
{
    my ($server,$target,$nick,$address,$ingamenick,$overwrite)=@_;
#    print $address;
    my ($name,$host) = $address =~ /(.+)@(.*)/;
    my $changed = 0;
#    print "$name $host";
    if ( $host =~ /.+\.users\.quakenet\.org/ ) #has Q auth
    {
	if ((defined ($ignames->{ $host })) && !($overwrite)){$server->command("MSG $target Your host $host is already in the list. Your ingame nick is $ignames->{ $host }. Use !${TE}bc2hello <${VA}bc2 nick${TE}> ${TE}yes to overwrite it."); return;}
    $ignames->{ $host }=$ingamenick;
    $server->command("MSG $target ${VA}$nick${TE}, your host ${VA}$host ${TE}is now linked to the ingame nick ${VA}$ignames->{ $host }${TE}.");
    $changed=1;
    }

    elsif ((defined ($ignames->{ $nick })) && !($overwrite)){$server->command("MSG $target You are already in the list. Your ingame nick is $ignames->{ $nick }. Use !${TE}bc2hello <${VA}bc2 nick${TE}> ${TE}yes to overwrite it."); return;}
    else {
    $ignames->{ $nick }=$ingamenick;
    $server->command("MSG $target ${VA}$nick${TE}, you are now linked to the ingame nick ${VA}$ignames->{ $nick }${TE}.");
    $changed =1;
    }
    if ($changed) {
    my $outtext=encode_json($ignames);
    open( my $out, ">", $NAMEFILE ) or print "Couldn't write cachefile!";
    print $out "$outtext";
    close($out);
    return;
    }
    return;
}

sub SCORE
{
    my ($server,$target,$dude)=@_;
    my $stats=&GETDATA($dude,'general',$server,$target,0);
    return if not defined($stats);
    my @lines;
    $lines[0] = "${BR}[ ${TE}$stats->{'players'}[0]->{'name'} ${BR}- ${TE}Score: ${VA}$stats->{'players'}[0]->{'score'} ${BR}- ${TE}Global rank: ${VA}$stats->{'players'}[0]->{'general'}->{'score_rank'} ${BR}]";
    $lines[1] = "${BR}[ ${TE}By kit: Assault: ${VA}$stats->{'players'}[0]->{'general'}->{'sc_assault'} ${BR}- ${TE}Engie: ${VA}$stats->{'players'}[0]->{'general'}->{'sc_demo'} ${BR}- ${TE}Medic: ${VA}$stats->{'players'}[0]->{'general'}->{'sc_support'} ${BR}- ${TE}Recon: ${VA}$stats->{'players'}[0]->{'general'}->{'sc_recon'} ${BR}- ${TE}Vehicle: ${VA}$stats->{'players'}[0]->{'general'}->{'sc_vehicle'} ${BR}]";
    $lines[2] = "${BR}[ ${TE}By source: Objective: ${VA}$stats->{'players'}[0]->{'general'}->{'sc_objective'} ${BR}- ${TE}Squad: ${VA}$stats->{'players'}[0]->{'general'}->{'sc_squad'} ${BR}- ${TE}Team: ${VA}$stats->{'players'}[0]->{'general'}->{'sc_team'} ${BR}- ${TE}Award: ${VA}$stats->{'players'}[0]->{'general'}->{'sc_award'} ${BR}- ${TE}Bonus: ${VA}$stats->{'players'}[0]->{'general'}->{'sc_bonus'} ${BR}- ${TE}General: ${VA}$stats->{'players'}[0]->{'general'}->{'sc_general'} ${BR}]";
    foreach(@lines){
	$server->command("MSG $target $_");
    }



}

#TODO prototype pugbot <- working pretty well actually.
#Irssi::settings_add_str('bc2bot','pugtopic','Type 11!10help for such 14| 10Games11:');
Irssi::settings_add_str('bc2bot','pugtopic',' 14| Type 11!10help for such');

#our %pug;
&READPUGS();

$pug->{'topic'}="No Games :( 14| Type 11!10add 11<15game11> <15size11> to start one!" .Irssi::settings_get_str('pugtopic');
#$pug{num}=0;
Irssi::signal_add('message nick','pug_nickevent');


Irssi::signal_add('message kick','pug_rem_kick_part');
Irssi::signal_add('message part','pug_rem_kick_part');

sub pug_rem_kick_part
{
    if ($pug->{'num'} == 0) { return; } #no pugs, no removing!
    my($server,$target,$nick)=@_;
    if ((Irssi::settings_get_str('bc2chans') =~ /$target(\s|$)/i ) || (Irssi::settings_get_str('bc2chans') eq "all")) {
#    my($server,$target,$nick)=@_;
    pug_rem($server,$nick);
    }
}


Irssi::signal_add('message quit','pug_rem_quit');

sub pug_rem_quit
{
    if ($pug->{'num'} == 0) { return; } #no pugs, no removing!
    my($server,$nick)=@_;
    pug_rem($server,$nick);
}


sub pug_topic
{
#print "updating topic";
    my ($server,$target)=@_;
    my $topicend=Irssi::settings_get_str('pugtopic');
    my $topicpre="Games:";
    my $topic="$topicpre";
    my $n=0;
    for my $key (keys %$pug) {
	if ((ref($pug->{$key}) eq "HASH") && (defined $pug->{$key}->{'name'})) {
#	    print "aparantly found game";
	    $n++;
	    if (not defined $target) {
		$target=$pug->{$key}->{'chan'};
	    }
	    my $players = join("${BR}\/${VA}",@{$pug->{$key}->{'list'}});
	    #my $players = join(',',@{$pug->{$key}->{'list'}});
	    $topic="$topic"." ${BR}$pug->{$key}->{'name'}${TE}:${VA} "."$players"." ${BR}(${VA}$pug->{$key}->{'added'}${BR}\/${VA}$pug->{$key}->{'size'}${BR})";
	 }

    }
    $topic="$topic"."$topicend";
    if ($n == 0) { $topic="$pug->{'topic'}"; }
    $server->command("TOPIC $target $topic");

    #write to disk
    my $outtext=encode_json($pug);
    open( my $out, ">", $PUGFILE ) or print "Couldn't write pugfile!";
    print $out "$outtext";
    close($out);
    return;

}


sub pug_add
{

#print "adding" . "@_";
    my ($server,$target,$nick,$game,$num)=@_;
    #!add bc2 3
#    print "THE GAME: $game";
    if (not defined $game) {
	if ($pug->{'num'} == 1) {
	    for my $key (keys %$pug) {
		if ((ref($pug->{$key}) eq "HASH") && (defined $pug->{$key}->{'name'})) {
		    $game=$pug->{$key}->{'name'};
		}
	    }
	}
	else {
	    $server->command("MSG $target To what game do you want to add?");
	    return;
	}
    }


    if (defined ($pug->{$nick})) {
	if ($game ne $pug->{$nick}) {
	    $server->command("MSG $target $nick, you are already added for $pug->{$nick}!");
	    }
	return;
    }

    if (defined ($pug->{$game})) {
	$pug->{$game}->{'added'}++;
	push (@{$pug->{$game}->{'list'}},$nick);
	$pug->{$nick}=$game;
	if ($pug->{$game}->{'added'} == $pug->{$game}->{'size'}){
	    #START PUG, remove everything.
	    my $text="Hey ".join(", ",@{$pug->{$game}->{'list'}}) .", your game of $pug->{$game}->{'name'} has gathered. Meet up in TS or something!";
	    $server->command("MSG $target $text");
	    for (my $n=0; $n < $pug->{$game}->{'added'}; $n++){
		$server->command("MSG $pug->{$game}->{'list'}[$n] Your game of $pug->{$game}->{'name'} has gathered. Meet up in TS or something!");
		delete $pug->{$pug->{$game}->{'list'}[$n]};
	    }
	    delete $pug->{$game};
	    $pug->{'num'}--;

	}
    }
    else {
	if (not defined $num) {
	    $server->command("MSG $target $nick, there is no game of $game waiting to gather yet. To create a gather, use ${BR}!${TE}add $game <${VA}size${TE}>"); return;
	}
	elsif (( $num < 2 ) || ($num > 10)) { $server->command("MSG $target Please, be reasonable. Allowed sizes: 2-10"); return; }

	#Create everything
	$pug->{$game}->{'size'}=$num;
	$pug->{$game}->{'added'}=1;
	$pug->{$game}->{'name'}=$game;
	$pug->{$nick}=$game;
	$pug->{$game}->{'chan'}=$target;
	push (@{$pug->{$game}->{'list'}},$nick);
	$pug->{'num'}++;
	$server->command("MSG $target $nick wants to play a round of $pug->{$game}->{'name'}. Type ${VA}!${TE}add $pug->{$game}->{'name'} to add up!");
    }
#    print "@{$pug->{$game}->{'list'}}";
#    for my $key (keys $pug) { print "$key, $pug->{$key}"; }
    pug_topic($server,$target);
}

sub pug_rem
{

#print "removing" . "@_";
    my ($server,$nick)=@_;
    my $target;
    if ($pug->{'num'} == 0) { return; } #no pugs, no removing!
    if (defined ($pug->{$nick})){

#    print "@{$pug{$pug{$nick}}{'list'}}";


	for (my $n=0; $n < $pug->{$pug->{$nick}}->{'added'}; $n++){
	    if ($pug->{$pug->{$nick}}->{'list'}[$n] eq $nick) {
		splice(@{$pug->{$pug->{$nick}}->{'list'}},$n,1);
		$target=$pug->{$pug->{$nick}}->{'chan'};
		last;
	    }
	}
#	print "@{$pug{$pug{$nick}}{'list'}}";


	$pug->{$pug->{$nick}}->{'added'}--;
	if ($pug->{$pug->{$nick}}->{added} == 0) {
	    delete $pug->{$pug->{$nick}};
	    $pug->{'num'}--;
	}
	delete $pug->{$nick};
    }
    #for my $key (keys %pug) { print "$key, $pug{$key}"; }
    pug_topic($server,$target);
#    $server->command("MSG $target $nick removed.");
}


sub pug_nickevent
{

#print "nickevent"."@_";
    my($server,$newnick,$oldnick)=@_;
    my $target;
    if ($pug->{'num'} == 0) { return; } #no pugs, nothing to do!
    if (defined ($pug->{$oldnick})){
	for (my $n=0; $n < $pug->{$pug->{$oldnick}}->{'added'}; $n++){
	    if ($pug->{$pug->{$oldnick}}->{'list'}[$n] eq $oldnick) {
		splice(@{$pug->{$pug->{$oldnick}}->{'list'}},$n,1);
		push(@{$pug->{$pug->{$oldnick}}->{'list'}},$newnick);
		$target=$pug->{$pug->{$oldnick}}->{'chan'};
		last;
	    }
	}
	$pug->{$newnick}=$pug->{$oldnick};
	delete $pug->{$oldnick};
    }
#    for my $key (keys %pug) { print "$key, $pug{$key}"; }
    pug_topic($server,$target);

}


#TRANSLATOR

Irssi::settings_add_str('bc2bot','apikey','YOUR KEY HERE');

our $turl="https://www.googleapis.com/language/translate/v2";

sub gtrans
{
    my ($server,$target,$source,$source_lan,$lan)=@_;
    $source =~ s/ |\N{U+3000}|\s/\%20/g;
    $source =~ s/"//g;
    #print $source;
    my $sstr="";
    my $slan="";
    if (not defined $lan) { $lan="en"; }
    if (not defined $source_lan) { $sstr=""; } else { $sstr="&source=${source_lan}"; $slan="$source_lan"; }
    #if (defined($slan) && ($slan eq $lan)) {
	#$server->command("MSG $target ${RED}Invalid language pair ($source_lan\-\>$lan)");
	#return;
    #}

#    print "$source";
#    my $lan=getlang($server,$target,$source);
#    if ($lan eq "ERROR" ) { return; }
#    elsif ($lan eq "en") { $server->command("MSG $target Shit's english, leave me alone"); return; }
    my $url="\"${turl}?key=". Irssi::settings_get_str('apikey'). "${sstr}&target=${lan}&q=${source}\"";
    my $json=qx(curl -s --globoff $url);
#    print "$json";
    if (defined $json) {
	unless ( $json =~ /^\{/ ) { print "Error in translation"; return "ERROR"; }
	my $dat=decode_json($json);
#ERROR CATCHING
	    if (defined $dat->{'data'}->{'translations'}[0]->{'detectedSourceLanguage'} ) {
		$slan="$dat->{'data'}->{'translations'}[0]->{'detectedSourceLanguage'}";
	    }
	    my $translation=html_dec($dat->{'data'}->{'translations'}[0]->{'translatedText'});
#	    my $translation="$dat->{'data'}->{'translations'}[0]->{'translatedText'}";
	    if (defined $translation) {
#	    print "$target $translation";
	    utf8::decode($target);
#	    print $target;
	    $server->command("MSG $target 14Google translation (${TE}${slan}${BR}\->${TE}${lan}14): $translation");
	    } else { $server->command("MSG $target no.");
	    }
    }
}


#not actually used anymore i think.
sub getlang
{
    my ($server,$target,$source)=@_;
    #print "$source";
    my $url="\'$turl"."/detect?key=". Irssi::settings_get_str('apikey'). "&q=${source}\'";
    #print $url;
    my $json=qx(curl -s --globoff $url);
    if (defined $json) {
	unless ( $json =~ /^\{/ ) { print "Error in translation"; return "ERROR"; }
#	print $json;
	my $dat=decode_json($json);
#ERROR CATCHING
#	print "$dat";
#	print "$dat->{'data'}->{'detections'}[0][0]->{'language'}";
	return "$dat->{'data'}->{'detections'}[0][0]->{'language'}";
    } else {
	$server->command("MSG $target Bi0 is too lazy to fix your fail, so the script will stop here");
	return "ERROR";
    }
}

sub GETNICK
{
    my ($nick,$address)=@_;
    my ($name,$host) = $address =~ /(.+)@(.*)/;
    if (( $host =~ /.+\.users\.quakenet\.org/ ) && (defined $ignames->{ $host }))
    { return $ignames->{ $host }; }
    elsif (defined ($ignames->{ $nick })) {return $ignames->{ $nick }; }
    else { return undef; }
}

our $languages="af|sq|ar|be|bg|ca|zh\-CN|zh\-TW|hr|cs|da|nl|en|et|tl|fi|fr|gl|de|el|ht|iw|hi|hu|is|id|ga|it|ja|lv|lt|mk|ms|mt|no|fa|pl|pt|ro|ru|sr|sk|sl|es|sw|sv|th|tr|uk|vi|cy|yi";

sub DOSTUFF
{
    my ($server,$msg,$nick,$address,$target) = @_;

    if ($msg =~ /(^\!about)(\s|$)/) { $server->command("MSG $target ${TE}bc2bot.pl version ${VA}$VERSION ${TE}by ${VA}Bi()ha2arD"); }

    elsif ((Irssi::settings_get_str('bc2chans') =~ /$target(\s|$)/i ) || (Irssi::settings_get_str('bc2chans') eq "all")) {
	if ($msg =~ /^\!bcs\s([a-zA-Z0-9_ \.~\(\)\/]+)$/) { &STATISTICS($1,$server,$target); }
	elsif ($msg =~ /^\!status\s([a-zA-Z0-9_ \.~\(\)\/]+)$/) { &STATUS($1,$server,$target); }
	elsif ($msg =~ /^\!guns(\sall)?$/) { my $name=&GETNICK($nick,$address); if ( defined $name ){&WEAPONS($name,$server,$target,$nick,$1); } else { $server->command("MSG $target ${TE}You have no ingame nick associated to your name, $nick. Use ${VA}!${TE}bc2hello <${VA}ingame nick${TE}> to link your IRC to your ingame nick!");} }


	elsif ($msg =~ /^\!guns\s([a-zA-Z0-9_ \.~\(\)\/]+)(\sall)?$/) { &WEAPONS($1,$server,$target,$nick,$2); }

	elsif ($msg =~ /^\!bcs$/) { my $name=&GETNICK($nick,$address); if ( defined $name ){&STATISTICS($name,$server,$target); } else { $server->command("MSG $target ${TE}You have no ingame nick associated to your name, $nick. Use ${VA}!${TE}bc2hello <${VA}ingame nick${TE}> to link your IRC to your ingame nick!");} }
	elsif ($msg =~ /^\!status$/) { my $name=&GETNICK($nick,$address); if ( defined $name ){&STATUS($name,$server,$target); } else { $server->command("MSG $target ${TE}You have no ingame nick associated to your name, $nick. Use ${VA}!${TE}bc2hello <${VA}ingame nick${TE}> to link your IRC to your ingame nick!");} }


	elsif ($msg =~ /^\!add(?:\s([a-zA-Z0-9]+))?(?:\s([0-9]+))?$/) {
#	    if ((not defined $1) && ($pug{'num'} == 1)) {
#		for my $key (keys %pug) {
#		    if ((ref($pug{$key}) eq "HASH") && (defined $pug{$key}{'name'})) {
#			pug_add($server,$target,$nick,$pug{$key}{'name'},$2);
#		    }
#		}
#	    }
#	    else {
		&pug_add($server,$target,$nick,$1,$2);
#	    }
	}
	elsif ($msg =~ /^\!remove(\s|$)/) { &pug_rem($server,$nick); }
#	elsif ($msg =~ /^\!add(\s|$)/) { $server->command("MSG $target To what game do you want to add, $nick?"); }

	elsif ($msg =~ /^\!score$/) { my $name=&GETNICK($nick,$address); if ( defined $name ){&SCORE($server,$target,$name); } else { $server->command("MSG $target ${TE}You have no ingame nick associated to your name, $nick. Use ${VA}!${TE}bc2hello <${VA}ingame nick${TE}> to link your IRC to your ingame nick!");} }


	elsif ($msg =~ /^\!score\s([a-zA-Z0-9_ \.~\(\)\/]+)$/) { &SCORE($server,$target,$1); }




	elsif ($msg =~ /^\!bc2hello\s([a-zA-Z0-9_ \.~\(\)\/]+)(\syes)?$/) { &HELLO($server,$target,$nick,$address,$1,$2); }
        elsif ($msg =~ /(^\!online)(\s|$)/) { &OLCHECK($server,$target); }
	elsif ($msg =~ /(^\!last)(\s|$)/) { &LASTOUT($server,$target); }
        elsif ($msg =~ /^\!bc2find\s([a-zA-Z0-9 \.~\(\)\/]+)$/) { &FIND($1,$server,$target); }
        elsif ($msg =~ /(^\!help)(\s|$)/) { my $TEXT = "${BR}usage: ${VA}" .
	"!${TE}bcs <${VA}player name${TE}> ${BR}to see player stats ${VA}| " .
	"!${TE}guns <${VA}player name${TE}> ${BR}to see top 3 weapons ${VA}| " .
	"!${TE}status <${VA}player name${TE}> ${BR}shows status information for stats ${VA}| " .
	"!${TE}online ${BR} to see who\'s playing (ask Bi() to be registered in the list) (PM) ${VA}| " .
	"!${TE}last ${BR}shows the last game ${VA}| " .
	"!${TE}bc2find <${VA}player name${TE}> ${BR} to get server info" .
	"\n" .
	"${VA}!${TE}list ${BR}to see who is in the !online list ${VA}| ".
	"!${TE}active ${BR}to see who played in the last month (PM) ${VA}| " .
	"!${TE}top10 ${BR}and ${VA}!${TE}addicted ${BR}for leaderboards (PM) ${VA}| " .
	"!${TE}ts ${BR}for TS ip and pw" .
	"\n" .
	"${VA}!${TE}bc2hello <${VA}bc2 nick${TE}> ${TE}[${VA}yes${TE}]${BR} (Experimental!) to associate your Q auth/IRC nick to your BC2 nick. You can then use !bcs, !guns and !status without arguments to see your stats. Use yes to overwrite nicks.";
	my @LINES=split("\n",$TEXT);
	foreach(@LINES) {$server->command("MSG $target $_");}
	}
	#elsif ($msg =~ /(^\!about)(\s|$)/) { $server->command("MSG $target ${TE}bc2bot.pl version ${VA}$VERSION ${TE}by ${VA}Bi()ha2arD"); }
	elsif ($msg =~ /(^\!list)(\s|$)/) {
	    my @GUYS=split(",",Irssi::settings_get_str('onlinelist'));
	    my $TEXT = "${TE}Players in the !online list: ${VA}" . "@GUYS";
	    $server->command("MSG $nick $TEXT"); }
	elsif ($msg =~ /(^\!top10)(\s|$)/) { #&TOPTEN($server,$nick,'0');
	    $server->command("MSG $nick $cache->{ 'top10' }"); }
	elsif ($msg =~ /(^\!addicted)(\s|$)/) { #&TOPTEN($server,$nick,'1');
	    $server->command("MSG $nick $cache->{ 'addicted' }"); }
	elsif ($msg =~ /(^\!active)(\s|$)/) { #&ACTIVE($server,$nick);
	    $server->command("MSG $nick $cache->{ 'active' }"); }
	elsif ($msg =~ /(^\!ts)(\s|$)/){
	    my $TSINFO=Irssi::settings_get_str('tsinfo');
	    $server->command("MSG $target $TSINFO"); }


    }

    if (((Irssi::settings_get_str('urlchans') eq "all") || (Irssi::settings_get_str('urlchans') =~ /$target(\s|$)/i)) && (Irssi::settings_get_bool('urltitle'))) {
	if ($msg =~ /((((https?|ftp):\/\/)|www\.)([a-zA-Z0-9\-]+\.)*[a-zA-Z0-9\-]+\.(com|net|org|info|biz|gov|name|edu|[a-zA-Z][a-zA-Z])(:[0-9]+)?((\/|\?)[^`\$ "]*[^ `,;\.\$:">)])?)/ ) { &GETTITLE($server,$target,$1); }
    }

    #if ((Irssi::settings_get_bool('translate')) && ( $msg =~ /(?:^\!translate \")([^"`´;\(\)\[\]\{\}\$\@\%\\]+)\"(?:\s($languages)?(?:\s)?->(?:\s)?($languages)?$)?/)) {
    if ((Irssi::settings_get_bool('translate')) && ( $msg =~
    /(?:^\!translate )([^`´;\(\)\[\]\{\}\$\@\%\\]+)/)) {
	my @string = $msg =~ /\s([^\s]+)/g;
	my @lang;
#	foreach my $index (0 .. $#string) {
#	    print $string[$index];
#	}
	if ($string[scalar(@string)-1] =~ /($languages)?->($languages)?/ ) {
	    #print "$1 $2";
	    $lang[0] = $1;
	    $lang[1] = $2;
	    if ( (not defined($lang[0])) && ($string[scalar(@string)-2] =~ /^($languages)$/) )  {
		#print "in -2 $1";
		$lang[0] = $1;
		#delete $string[scalar(@string)-1];
		$string[scalar(@string)-2] = "";
	    }
	    $string[scalar(@string)-1] = "";

	} elsif ($string[scalar(@string)-2] =~ /^\->$/) {
	    if ($string[scalar(@string)-3] =~ /^($languages)$/ ) {
		$lang[0] = $string[scalar(@string)-3];
		$string[scalar(@string)-3] = "";
	    }
	    $lang[1] = $string[scalar(@string)-1] if ($string[scalar(@string)-1] =~ /^$languages$/ );


	    $string[scalar(@string)-1] = "";
	    $string[scalar(@string)-2] = "";


	} elsif ($string[scalar(@string)-2] =~ /^($languages)->$/) {
	    $lang[0]=$1;
	    $lang[1]=$string[scalar(@string)-1] if ($string[scalar(@string)-1] =~ /^$languages&/);
	    $string[scalar(@string)-1] = "";
	    $string[scalar(@string)-2] = "";

	}
	#foreach my $index (0 .. $#string) {
	#    print $string[$index];
	#}
#	if (defined($lang[0]) || defined($lang[1])) {
#	    delete $string[scalar(@string)-1];
#	}
	my $text = join(' ',@string);
	#print "$lang[0] $lang[1]";
	&gtrans($server,$target,$text,$lang[0],$lang[1]);
    }
    if ((Irssi::settings_get_bool('translate')) && ( $msg =~ /(?:^\!languages)(\s|$)/ )) {
	my $langs = $languages;
	$langs =~ s/\|/, /g;
	$server->command("MSG $target Available languages: $langs");
    }



}



sub STARTLAST {
    unless (defined $TIMEOUT){
    my ($data,$server,$witem)=@_;
    my @args = qw($server $witem->{name});
#SHOULDNT NEED THE CHECKS BECAUSE WE FAIL SILENT NOW
#    if (!$server || !$server->{ connected } ){print "Not connected to a server"; return;}
#    if ($witem->{type} eq "CHANNEL"){
	$TIMEOUT=Irssi::timeout_add(Irssi::settings_get_int('lastdelta')*60000, "LAST", "@args");
	print "Checking updates periodically every " . Irssi::settings_get_int('lastdelta') ." minutes.";
#    }
    } else { print "Updates already started!"; }
}




Irssi::signal_add('message public','DOSTUFF');

Irssi::settings_add_str('bc2bot','onlinelist','Bi()ha2arD,ZenMaster.jW,~Ducky~,dmnc,UponAll1,EuXeu5,Nammo,retiredCamel,Waaambulance');

Irssi::command_bind('bc2cols',"UPDATECOLS");

Irssi::settings_add_bool('bc2bot','urltitle','1');
Irssi::settings_add_str('bc2bot','urlchans','all');
Irssi::settings_add_str('bc2bot','bc2chans','all');

Irssi::settings_add_bool('bc2bot','translate','1');

Irssi::command_bind('lastud',"LAST");
Irssi::settings_add_int('bc2bot','lastdelta','10');
Irssi::command_bind('laststart', "STARTLAST");
Irssi::command_bind('laststop', sub { if (defined $TIMEOUT){Irssi::timeout_remove($TIMEOUT); $TIMEOUT = undef; print "Periodic updates stopped."; } });

Irssi::settings_add_str('bc2bot','tsinfo','No TS info.');

#START UPDATING ON SCRIPT LOAD
&READCACHE();
&READNAMES();
&STARTLAST();


#TIMEBOMB DEFUSER (cuz i was bored)
Irssi::signal_add('message irc action','defuse');

sub defuse
{
    my ($server,$msg,$nick,$addr,$target)=@_;
    #print "$msg, $server->{'nick'}";
    if ( ($nick eq "AiMBoT" ) && ($msg =~ /stuffs the bomb into $server->{'nick'}\'s pants\.  The display reads/ )) {
    #print "got timebombed";
	Irssi::signal_add('message public','defuse_cut');
    }
}

sub defuse_cut
{

    #print "defusing start";
    my ($server,$msg,$nick,$addr,$target)=@_;
    #print "$msg";

  #  if ( ($nick eq "AiMBoT" ) && ($msg =~ /Diffuse the bomb by using \!cut \<color\>or color-command\. There are \w wires\. They are (?:\16(\!\S+)(?:(?: and )|(?:\.)|(?:, )))+/ )) {
   # if ( ($nick eq "AiMBoT" ) && ($msg =~ /Diffuse the bomb by using(?:.+)or color-command\. There are \w wires\. They are (.+$)/ )) {
    if ( ($nick eq "AiMBoT" ) && ($msg =~ /They are(.+)$/ )) {

	my @colours = $1 =~ /(\![a-zA-Z]+)/g;
#	print "defusing";
#	print "@colours";# | $2 | $3 | $4 | $5";
	my $num=int(rand(int(@colours)));
	$server->command("MSG $target $colours[$num]");
	Irssi::signal_remove('message public','defuse_cut');
    }
#    Irssi::signal_remove('message public','defuse_cut');

}
